/*
	CGI Source for TextBoard.Cgi
	make 'guest#.html"

	Author	: Kang Jul Ki
	E-mail	: jkkang@sel.chonbuk.ac.kr
	Homepage: http://sel.chonbuk.ac.kr/~jkkang/
	Date	: February 3, 1997
	Class	: Software Engineering Lab.
		  Dept. of Electronic Engineering
		  Chonbuk National Univ.	

	Compiler: Visual C++ 4.0
	Copyright (c) 1997, Kang Jul Ki & Software Engineering Lab.
*/

#include "mycgi.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

FILE_HEADER	fheader;
int		iTN;

/*
** Program entry
*/
void main()
{
	int	i, iTotal;
	char	*buf, fname[255] = "", dir[200];
	entry	inparam[MAX_ENTRIES];
	int	iBoardNum, iTextNum;
	int	iBoard, iStart, iEnd;
	FILE	*fpt;

	/*
	** Mime type
	*/
	printf("Content-type: text/html%c%c", LF, LF);

	buf = getenv("QUERY_STRING");

	for (i=0; i<3; i++)
	{
		inparam[i].f_val = (char *)makeword(buf, '&');
		inparam[i].f_name = (char *)makeword(inparam[i].f_val, '=');
#ifdef _DEBUG_
		printf("%s%c", inparam[i].f_name, LF);
		printf("%s<br>%c", inparam[i].f_val, LF);
#endif
	}

	/*
	** Set iBoardNum and iTextNum
	*/
	iBoardNum = atoi(inparam[0].f_val);
	iTextNum  = atoi(inparam[1].f_val);
	sprintf(dir, "%s", inparam[2].f_val);


	if (dir[strlen(dir)-1] != '\\')		/* dir must contain '\\'	*/
	{
		strcat(dir, "\\");
	}

	/*
	** Open data file ('guest.dat')
	*/
	sprintf(fname, "%s%s", dir, "guestbook.dat");

	fpt = fopen(fname, "r");

	/*
	** not found 'guestbook.dat'
	*/
	if (fpt == NULL)
	{
		ShowStart(dir);
		//printf("CheckCheck%c", LF);
		return;
	}

	fread(&fheader, HEADER_SIZE, 1, fpt);
	iBoard = atoi(fheader.szPageNum);	/* Read last board page	*/

#ifdef _DEBUG_
	printf("iBoardNum = %d iTextNum = %d%c", iBoardNum, iTextNum, LF);
#endif
	fclose(fpt);

	/*
	** Make file name (guest#.html)
	*/
	sprintf(fname, "%s\\guest%d.html", dir, iBoard);

#ifdef _DEBUG_
	printf("fname = %s%c", fname, LF);
#endif
	/*
	** Show guest#.html in the screen
	*/
	printf("<html>%c", LF);
	printf("<body bgcolor=\"ffffff\" background=\"/Image/background.jpg\">%c", LF);

	printf("<center>%c", LF);
	printf("<img src=\"/Image/guest.gif\" width=240 height=60 border=0>%c", LF);

	printf("<table border=0 width=480 cellspace=3>%c", LF);
		printf("<tr>%c", LF);
			printf("<td valign=buttom>%c", LF);
			printf("<img align=left border=0 src=\"/Image/bookpen.gif\">%c", LF);

			printf("<br>%c", LF);
			printf("<img width=420 src=\"/Image/line_ani.gif\">%c", LF);
			printf("</td>%c", LF);
		printf("</tr>%c", LF);
	printf("</table>%c", LF);
	printf("</center>%c", LF);
	printf("<center>%c", LF);
	printf("<table border=0 cellspace=3 align=absmiddle><tr><th><pre>  ۹ȣ  </pre></th><th><pre>  ۾  </pre></th><th><pre>  ۾¥  </pre></th><th><pre>  Ƚ  </pre></th><th><pre>    </pre></th></tr>%c", LF);

	/*
	** Get iStart and iEnd
	*/
	iTotal = atoi(fheader.szTotal);

	iTN = iTextNum;
	if (iBoardNum == 0 && iTextNum == 0)
		GetArgument(0, 0, &iStart, &iEnd, iTotal);
	else
		GetArgument(iBoardNum, iTextNum, &iStart, &iEnd, iTotal);

	ShowBoard(dir, iBoardNum, iStart, iEnd, iTotal);
}

/*
** GetArgument()
*/
void GetArgument(bn, tn, start, end, total)
int bn, tn;
int *start;
int *end;
int total;
{
#ifdef _DEBUG_
	printf("bn = %d tn = %d%c", bn, tn, LF);
#endif

	/* start(1) < end(10	*/
	if (total > 0 && total < 11)
	{
		*start = 1;
		*end   = total;
	}
	else	/* total > 11	*/
	{
		if (bn == 0 && tn == 0)
		{
			*start = total-9;
			*end   = total;
		}
		else
		{
			*start = tn-9;
			*end   = tn;

			if (*start <= 0)
			{
				*start = 1;
				// *end   = tn;
				*end = 10;
				*end = (*end >= total) ? total : *end;
			}
		}

	}

#ifdef _DEBUG_
	printf("*start = %d, *end = %d, total=%d%c", *start, *end, total, LF);
#endif

}

/*
** ShowBoard()
*/
void ShowBoard(dir, board, iStart, iEnd, total)
char *dir;
int board;
int iStart;
int iEnd;
int total;
{
	int	i, iLeftTextNum;//, iRightTextNum;
	RECORD	buf;
	FILE	*fpt;
	long	size;
	char	fname[200];

	/*
	** Open data file ('guestbook.dat')
	*/
	sprintf(fname, "%s%s", dir, "guestbook.dat");
	fpt = fopen(fname, "r");

	if (fpt == NULL)
	{
		char str[100];
		
		sprintf(str, "Can't open %s", fname);
		ShowErrorMsg(dir, str);
		//exit(1);
	}

	for (i=iEnd; i>=iStart; i--)
	{
		size = (total - i + 1) * -(int)(RECORD_SIZE);

#ifdef _DEBUG_
	printf("size = %d%c", size, LF);
#endif
        	fseek(fpt, size, SEEK_END);
		fread(&buf, RECORD_SIZE, 1, fpt);

		printf("<tr>");
		printf("<td align=center>%s</td>", buf.szNumber);

		printf("<td align=center>%s</td>", buf.szName);
		printf("<td align=center>%s</td>", buf.szDate);
		printf("<td align=center>%s</td>", buf.szCount);
		printf("<td align=center><a href=\"/cgi-bin/TextRead.exe?BoardNum=%d&TextNum=%s&Dir=%s\">%s</a></td></tr>%c%c", 1, buf.szNumber, dir, buf.szTitle, LF, LF);
	}

	printf("</table>%c", LF);
	printf("</center>%c", LF);

	iLeftTextNum = iStart - 1;

	printf("<br>%c", LF);
	printf("<center>%c", LF);

	if (iLeftTextNum != 0)
	{
		printf("<a href=/cgi-bin/TextBoard.exe?BoardNum=%d&TextNum=%d&Dir=%s>", board+1, iLeftTextNum, dir);
		printf("<img src=/Image/leftarrow.gif border=0></a>%c", LF);
	}

	printf("<a href=/Cgi-bin/TextHtml.exe?Dir=%s><img src=\"/Image/posting.gif\" align=absmiddle border=0></a>%c", dir, LF);

	printf("</center>%c", LF);

	printf("<p>%c", LF);
	printf("<center>%c", LF);
	printf("<img src=\"/Image/line.gif\">%c", LF);
	printf("<br>%c", LF);

#ifdef _PRO_
	printf("<font color=454545 size=-1>Professional Version 1.01</font><br>%c", LF);
#else
	printf("<font color=454545 size=-1>Amateur Version 1.01</font><br>%c", LF);
#endif
	printf("<font color=454545 size=-1>Copyright <font size=4>&copy</font> 1996 - 1997,%c", LF);
	printf("Software Engineering Lab. All rights reserved.</br>%c", LF);
	printf("Chonbuk National Univ. Dept. of Electronic Engineering<br>%c", LF);
	printf("<a href=http://sel.chonbuk.ac.kr/~jkkang/><blink>Programmed by Kang Jul Ki</blink></a><br>%c", LF);
	printf("<a href=mailto:%s>%s</a></br>%c", E_MAIL, E_MAIL, LF);
	printf("</font></center>%c", LF);
	printf("</body>%c", LF);
	printf("</html>%c", LF);

	fclose(fpt);
}

/*
** ShowStart()
*/
void ShowStart(char *dir)
{
	printf("<html>%c", LF);

	printf("<body bgcolor=\"ffffff\" background=\"/Image/background.jpg\">%c", LF);
	printf("<center>%c", LF);
	printf("<img src=\"/Image/guest.gif\" width=240 height=60 border=0>%c", LF);

	printf("<table border=0 width=480 cellspace=3>%c", LF);
	printf("<tr>%c", LF);
		printf("<td valign=buttom>%c", LF);
		printf("<img align=left border=0 src=\"/Image/bookpen.gif\">%c", LF);

		printf("<br>%c", LF);
		printf("<img width=420 src=\"/Image/line_ani.gif\">%c", LF);
		printf("</td>%c", LF);
	printf("</tr>%c", LF);
	printf("</table>%c", LF);
	printf("</center>%c", LF);
	printf("<center>%c", LF);
	printf("<table border=0 cellspace=3 align=absmiddle><tr><th><pre>  ۹ȣ  </pre></th><th><pre>  ۾  </pre></th><th><pre>  ۾¥  </pre></th><th><pre>  Ƚ  </pre></th><th><pre>    </pre></th></tr></table>%c", LF);

	printf("<br><br><br><br><br>%c", LF);
        printf("<blink><font color=2e8b57 size=-1>There is no data file!!!</font></blink><br>%c", LF);
       	printf("<blink><font color=ff1493 size=-1> ۼϼž߸ մϴ!!!</font></blink>%c", LF);
	printf("<br><br><br><br><br>%c", LF);

	printf("<a href=/Cgi-bin/TextHtml.exe?Dir=%s><img src=\"/Image/posting.gif\" align=absmiddle border=0></a>%c", dir, LF);

	printf("<p>%c", LF);
	printf("<center>%c", LF);
	printf("<img src=\"/Image/line.gif\">%c", LF);
	printf("<br>%c", LF);

#ifdef _PRO_
	printf("<font color=454545 size=-1>Professional Version 1.01</font><br>%c", LF);
#else
	printf("<font color=454545 size=-1>Amateur Version 1.01</font><br>%c", LF);
#endif
	printf("<font color=454545 size=-1>Copyright <font size=4>&copy</font> 1996 - 1997,%c", LF);
	printf("Software Engineering Lab. All rights reserved.</br>%c", LF);
	printf("Chonbuk National Univ. Dept. of Electronic Engineering<br>%c", LF);
	printf("<a href=http://sel.chonbuk.ac.kr/~jkkang/><blink>Programmed by Kang Jul Ki</blink></a><br>%c", LF);
	printf("<a href=mailto:%s>%s</a></br>%c", E_MAIL, E_MAIL, LF);
	printf("</font></center>%c", LF);
	printf("</body>%c", LF);
	printf("</html>%c", LF);
}