/*
	CGI Source for Guest book
	Erase one guestbook data

	Author	: Kang Jul Ki
	Date	: February 3, 1996
	Class	: Software Engineering Lab.
		  Dept. of Electronic Engineering
		  Chonbuk National Univ.	

	Compiler: Visual C++ 4.0
	Copyright (c) 1996, Dept. of Electronic Engineering
*/

#include "mycgi.h"
#include <stdio.h>
#include <stdlib.h>

FILE_HEADER	fheader;
RECORD		rcd;

/*
** The entry - main()
*/
void main()
{
	int	i, iNum, iTotal, iCount, rv;
	char	fname[256] = "", dir[256] = "";		/* Path & File name*/
	char	ff[256] = "";				/* Path & File name*/
	RECORD	*ptr, rcd;
	FILE_HEADER	fheader;
	FILE	*fpt, *fpt2;
	fpos_t	pos1, pos2;
	char	tmp[256]="", *buf, rm[256]="", *domain, *ip;
	entry	inparam[MAX_ENTRIES];

	/*
	** Get "QEURY_STRING"
	*/
	printf("Content-type: text/html%c%c", LF, LF);

	domain = (char *)getenv("REMOTE_HOST");
	ip     = (char *)getenv("REMOTE_ADDR");
	buf    = (char *)getenv("QUERY_STRING");

	for (i=0; i<2; i++)
	{
		inparam[i].f_val = (char *)makeword(buf, '&');
		inparam[i].f_name= (char *)makeword(inparam[i].f_val, '=');
	}


#ifdef _DEBUG_
	printf("%s%c", inparam[0].f_name, LF);
	printf("%s<br>%c", inparam[0].f_val, LF);
#endif


	/*
	** Open file
	*/
	iNum = atoi(inparam[0].f_val);		/* number of data	*/
	sprintf(dir, "%s", inparam[1].f_val);	/* Base directory	*/

	if (strcmp(domain, "check.chonbuk.ac.kr"))
	{
		ShowError(dir);
		return;
	}

	sprintf(fname, "%s%s", dir, "guestbook.dat");
	sprintf(ff, "%s", dir);			/* Copy Base directory	*/

	fpt = fopen(fname, "r+");

#ifdef _DEBUG_
	printf("fname = %s\n", fname);
#endif

	if (fpt == NULL)
	{
		char str[100];

		sprintf(str, "Can't open %s", fname);
		ShowErrorMsg(dir, str);
		//exit(1);
	}

	fread(&fheader	, HEADER_SIZE, 1, fpt);
	iTotal = atoi(fheader.szTotal);

	/*
	** total == 1 and iTextNum == 1
	** remove guestbook.dat and guestbook#.html
	*/
	if (iTotal == 1 && iNum == 1)
	{
#ifdef _DEBUG_
	printf("<br>iTotal = %d iNum = %d%c", iTotal, iNum, LF);
#endif
		int	rv1, rv2;

		fread(&rcd, RECORD_SIZE, 1, fpt);
		sprintf(rm, "%s%s", ff, rcd.szHtmlName);
		fclose(fpt);

		rv1 = remove(rm);
		rv2 = remove(fname);	/* remove guestbook.dat	*/

		if (rv1 == -1)
		{
			char str[100];
				
			sprintf(str, "Failed to remove %s", rm);
			ShowErrorMsg(dir, str);
			//printf("Failed to remove %s%c", rm, LF);
		}
		if (rv2 == -1)
		{
			char str[100];

			sprintf(str, "Failed to remove %s", fname);
			ShowErrorMsg(dir, str);
			//printf("Failed to remove %s%c", fname, LF);
		}

		ShowSuccess(dir);
		return;
	}


#if _DEBUG_
	printf("iTotal = %d num = %d\n", iTotal, iNum);
#endif

	/*
	** In case of no data
	*/
	if (iTotal == 0)
	{
		char str[100];

		sprintf(str, "There's no data %s", "guestbook.dat");
		ShowErrorMsg(dir, str);
	}

	sprintf(fheader.szTotal, "%d", iTotal-1);	/* iTotal--	*/
	fseek(fpt, 0L, SEEK_SET);			/* go to start	*/
	fwrite(&fheader, HEADER_SIZE, 1, fpt);		/* update header*/

#ifdef _DEBUG_
	printf("fheader.szTotal = %s\n", fheader.szTotal);
#endif

	/*
	** Memory allocation for record
	*/
	ptr = (RECORD *)malloc(RECORD_SIZE);
	if (ptr == NULL)
	{
		char str[100];

		sprintf(str, "%s", "Memory allocation Error!!!");
		ShowErrorMsg(dir, str);
		//printf("\nMemory allocation Error!!!\n");
		//exit(1);
	}

	if (iNum >= 1)
	{
		fseek(fpt, (long)(HEADER_SIZE+RECORD_SIZE*(iNum-1)), SEEK_SET);
		fgetpos(fpt, &pos1);
		fread(ptr, RECORD_SIZE, 1, fpt);
		sprintf(rm, "%s", ptr->szHtmlName);	/* remove guestbook#.html	*/

		fseek(fpt, (long)(HEADER_SIZE+RECORD_SIZE*iNum), SEEK_SET);
		fgetpos(fpt, &pos2);

		iCount = iTotal - iNum;

		for (i=0; i<iCount; i++)
		{
			fsetpos(fpt, &pos2);
			fread(ptr, RECORD_SIZE, 1, fpt);		/* read record	*/
			fgetpos(fpt, &pos2);
			sprintf(ptr->szNumber, "%d", (atoi(ptr->szNumber)-1));
#ifdef _DEBUG_
	printf("ptr->szNumber = %s\n", ptr->szNumber);
#endif
			fsetpos(fpt, &pos1);
			fwrite(ptr, RECORD_SIZE, 1, fpt);
			fgetpos(fpt, &pos1);
		}
	}

	/*
	** Update 'guestbook.dat' from temp file
	*/
	sprintf(tmp, "%s%s", dir, "tmp.dat");
	fpt2 = fopen(tmp, "w+");

	if (fpt2 == NULL)
	{
		char str[100];

		sprintf(str, "Can't open %s!!!", tmp);
		ShowErrorMsg(dir, str);
	}

	fseek(fpt, 0L, SEEK_SET);
	fread(&fheader, HEADER_SIZE, 1, fpt);
	fwrite(&fheader, HEADER_SIZE, 1, fpt2);

	for (i=0; i<iTotal-1; i++)
	{
		fread(ptr, RECORD_SIZE, 1, fpt);
		fwrite(ptr, RECORD_SIZE, 1, fpt2);
	}	

	free(ptr);
	fclose(fpt);		/* fname		*/
	fclose(fpt2);		/* tmp			*/

	rv = remove(fname);	/* remove guestbook.dat	*/

	if (rv == -1)		/* error		*/
	{
		char str[100];

		sprintf(str, "Failed to remove %s", fname);
		ShowErrorMsg(dir, str);
	}

	rv = rename(tmp, fname);

	if (rv == -1)		/* error		*/
	{
		char str[100];

		sprintf(str, "Failed to rename %s", tmp);
		ShowErrorMsg(dir, str);
	}

	/*
	** Remove 'guestbook#.html'
	*/
	sprintf(tmp, "%s%s", ff, rm);
	remove(tmp);

	if (rv == -1)		/* error		*/
	{
		char str[100];

		sprintf(str, "Failed to remove %s", tmp);
		ShowErrorMsg(dir, str);
	}
	else
	{
		ShowSuccess(dir);
	}
}


/*
** ShowError()
*/
void ShowError(dir)
char *dir;
{
	printf("<html>%c", LF);
	printf("<body bgcolor=ffffff background=/Image/background.jpg%c", LF);

	printf("<br>%c", LF);
	printf("<center>%c", LF);
	printf("<br><br><br><br>%c", LF);
	/*printf("<img src=/~jkkang/Image/blue_line.gif><br><br>%c", LF);*/

	printf("<font color=228b22 size=3>Access denied!!!</font><br>%c", LF);
        printf("<font color=454545 size=2>մ   ϴ.!!!</font><br>%c", LF);

	printf("<br><br>%c", LF);
	printf("<center>%c", LF);
	printf("<font color=4a708b size=-1>%c", LF);
	printf("<a href=/Cgi-bin/TextBoard.exe?BoardNum=0&TextNum=0&Dir=%s><img src=/Image/posting.gif border=0></a>%c", dir, LF);
	printf("<br>Click%c", LF);
	printf("</font>%c", LF);
	printf("</center>%c", LF);

	printf("<br><br><br><br><br>%c", LF);

	printf("<img src=/Image/line.gif width=500><br>%c", LF);

#ifdef _PRO_
	printf("<font color=454545 size=-1>Professional Version 1.01</font><br>%c", LF);
#else
	printf("<font color=454545 size=-1>Amateur Version 1.01</font><br>%c", LF);
#endif
	printf("<font color=454545 size=-1>Copyright <font size=4>&copy</font> 1996 - 1997,%c", LF);
	printf("Software Engineering Lab. All rights reserved.</br>%c", LF);
	printf("Chonbuk National Univ. Dept. of Electronic Engineering<br>%c", LF);
	printf("<a href=http://sel.chonbuk.ac.kr/~jkkang/><blink>Programmed by Kang Jul Ki</blink></a><br>%c", LF);
	printf("<a href=mailto:%s>%s</a></br>%c", E_MAIL, E_MAIL, LF);
	printf("</font>%c", LF);
	printf("</center>%c", LF);

	printf("</body>%c", LF);
	printf("</html>%c", LF);
}

/*
** ShowSuccess()
*/
void ShowSuccess(dir)
char *dir;
{
	printf("<html>%c", LF);
	printf("<body bgcolor=ffffff background=/Image/background.jpg%c", LF);

	printf("<br>%c", LF);
	printf("<center>%c", LF);
	printf("<br><br><br><br>%c", LF);

	printf("<font color=228b22 size=3>Successfully removed!!!</font><br>%c", LF);

	printf("<br><br>%c", LF);
	printf("<center>%c", LF);
	printf("<font color=4a708b size=-1>%c", LF);
	printf("<a href=/Cgi-bin/TextBoard.exe?BoardNum=0&TextNum=0&Dir=%s><img src=/Image/posting.gif border=0></a>%c", dir, LF);
	printf("<br>Click%c", LF);
	printf("</font>%c", LF);
	printf("</center>%c", LF);

	printf("<br><br><br><br><br>%c", LF);

	printf("<img src=/Image/line.gif width=500><br>%c", LF);

#ifdef _PRO_
	printf("<font color=454545 size=-1>Professional Version 1.01</font><br>%c", LF);
#else
	printf("<font color=454545 size=-1>Amateur Version 1.01</font><br>%c", LF);
#endif
	printf("<font color=454545 size=-1>Copyright <font size=4>&copy</font> 1996 - 1997,%c", LF);
	printf("Software Engineering Lab. All rights reserved.</br>%c", LF);
	printf("Chonbuk National Univ. Dept. of Electronic Engineering<br>%c", LF);
	printf("<a href=http://sel.chonbuk.ac.kr/~jkkang/><blink>Programmed by Kang Jul Ki</blink></a><br>%c", LF);
	printf("<a href=mailto:%s>%s</a></br>%c", E_MAIL, E_MAIL, LF);
	printf("</font>%c", LF);
	printf("</center>%c", LF);

	printf("</body>%c", LF);
	printf("</html>%c", LF);
}