/*
	TextPost.c (CGI Source for Guest book)

	Author	: Kang Jul Ki
	E-mail	: jkkang@sel.chonbuk.ac.kr
	Homepage: http://sel.chonbuk.ac.kr/~jkkang/
	Date	: February 3, 1997
	Class	: Software Engineering Lab.
		  Dept. of Electronic Engineering
		  Chonbuk National Univ.	

	Compiler: Visual C++ 4.0
	Copyright (c) 1997, Kang Jul Ki & Software Engineering Lab.
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <sys/timeb.h>
#include "mycgi.h"

void	Error	(char *dir);

FILE_HEADER	fheader;
RECORD		rcd;
	
char	fname[100];	//="/usr1/user/jkkang/public_html/bbs2/"; /* Path & File name*/
char	szHtmlFname[100] = "";

/*
** The entry - main()
*/
void main()
{
	int	i, cl;
	char	*whdomain, *whip, *server, *browser, dir[200];
	char	whtime[20], whdate[20];
	entry	inparam[MAX_ENTRIES];
	time_t	tmp_time1;
	struct	tm *tmp_time2;
	char	temp[100] = "",  szDate[50] = "";
	FILE	*fp;		//, *html_fpt;
	int	ch, nTotal, iIndex;
    
	printf("Content-type: text/html%c%c", LF, LF);

	/*
	** Get environment variable from www
	*/
	whdomain = getenv("REMOTE_HOST");
	whip     = getenv("REMOTE_ADDR");
	server	 = getenv("SERVER_NAME");
	browser  = getenv("HTTP_USER_AGENT");

	/*
	** Set time and date of writing
	*/
	tmp_time1 = time(0);
	tmp_time2 = localtime(&tmp_time1);
	strftime(whdate, 99, "%Y%m%d", tmp_time2);
	strftime(whtime, 99, "%H%M", tmp_time2);
	sprintf(szDate, "%s %s", whdate, whtime);

	/*
	** Get length of CONTENT_LENGTH
	*/
	cl = atoi((char *)getenv("CONTENT_LENGTH"));
    
	for(i=0; cl && (!feof(stdin)); i++)
	{
		inparam[i].f_val = (char *)fmakeword(stdin, '&', &cl);
		plustospace(inparam[i].f_val);
		unescape_url(inparam[i].f_val);
		inparam[i].f_name = (char *)makeword(inparam[i].f_val, '=');

#ifdef _DEBUG_
		printf("%s : %s%c<br>", inparam[i].f_name, inparam[i].f_val, LF);
#endif
	}

	/*
	** Make file name & path
	*/
	sprintf(dir, "%s", inparam[5].f_val);	// inparam[5] is dir
	sprintf(fname, "%s", dir);	

	/*
	** Show error message
	**	* Not write own's name
	**	* Not write title
	**	* Not write comment
	*/
	if (strlen(inparam[0].f_val) <= 0 ||
	    strlen(inparam[3].f_val) <= 0 ||
	    strlen(inparam[4].f_val) <= 0)
	{
	/* Return result into HTML document	*/
	/* Just write into stdout and exit(1)	*/
		Error(dir);
	}

	if (fname[strlen(fname)-1] != '\\')	// fname must be "c:\webser\fnord\bbs\"
	{
		strcat(fname, "\\");
	}

	strcat(fname, "guestbook.dat");

	//printf("fname = %s%c", fname, LF);

	fp = fopen(fname, "r+");

	if (fp == NULL)
	{					/* If file doesn't exist*/
		fp = fopen(fname, "w");		/* create file		*/

		sprintf(fheader.szTotal, "%d", 0);
		sprintf(fheader.szIndex, "%d", 0);
		fwrite(&fheader, HEADER_SIZE, 1, fp);
#ifdef _DEBUG_
		printf("<br>fname : %s<br>fheader.szTotal : %s<br>%c", fname, fheader.szTotal);
#endif 
	}

	fseek(fp, 0L, SEEK_SET);
	fread(&fheader, HEADER_SIZE, 1, fp);	/* read header	*/

	sscanf(fheader.szIndex, "%d", &iIndex);
	iIndex++;

	sscanf(fheader.szTotal, "%d", &nTotal);
	nTotal++;
	sprintf(rcd.szNumber, "%d", nTotal);
	sprintf(fheader.szIndex, "%d", iIndex);
	sprintf(fheader.szTotal, "%d", nTotal);
	sprintf(fheader.szPageNum, "%d", (nTotal/10)+1);

#ifdef _DEBUG_
	printf("<br>nTotal : %d<br>%c", nTotal, LF);
#endif

	strcpy(rcd.szName, inparam[0].f_val);
	strcpy(rcd.szEmail, inparam[1].f_val);
	strcpy(rcd.szDate, whdate);
	strcpy(rcd.szTitle, inparam[3].f_val);
	sprintf(rcd.szCount, "%4s", "0");

#ifdef _DEBUG_
	printf("<br>rcd.szName : %s rcd.szEmail : %s rcd.szDate : %s rcd.szTitle : %s%c<br>",
			rcd.szName, rcd.szEmail, rcd.szDate, rcd.szTitle, LF);
#endif

	sprintf(szHtmlFname, "%s\\%s%d.html", dir, "guestbook", iIndex);
	sprintf(rcd.szHtmlName, "%s%d.html", "guestbook", iIndex);

#ifdef _DEBUG_
	printf("<br>szHtmlFname : %s rcd.szHtmlName : %s%c<br>", szHtmlFname, rcd.szHtmlName, LF);
#endif

	fseek(fp, 0L, SEEK_SET);
	fwrite(&fheader, HEADER_SIZE, 1, fp);

	fseek(fp, 0L, SEEK_END);
	fwrite(&rcd, RECORD_SIZE, 1, fp);
	fclose(fp);

	/*
	** inparam[4].f_val is a comment
	*/

	fp = fopen(szHtmlFname, "w+");

	MakeEachHtmlPage(fp, inparam[4].f_val, inparam[2].f_val, whdomain, szDate);

	fclose(fp);

	/*
	** Show 'guestbook#.html' in the screen
	*/
	fp = fopen(szHtmlFname, "r");
	while ((ch=getc(fp)) != EOF)
		putchar(ch);
	fclose(fp);

	/*
	** Go to TextBoard
	*/
	printf("<br><br>%c", LF);
	printf("<center>%c", LF);
	printf("<font color=4a708b size=-1>%c", LF);
	printf("<a href=/cgi-bin/TextBoard.exe?BoardNum=0&TextNum=0&Dir=%s><img src=/Image/posting.gif border=0></a>%c", dir, LF);
	printf("<br>Click%c", LF);
	printf("</font>%c", LF);
	printf("</center>%c", LF);
}

/*
** guestbook10.html  ȭ 
*/
void MakeEachHtmlPage(fp, buf, homepage, url, szDate)
FILE *fp;
char *buf, *homepage, *url, *szDate;
{
	int	i;

	fprintf(fp, "<html>%c", LF);
	fprintf(fp, "<body bgcolor=\"ffffff\" background=\"/Image/background.jpg\">%c", LF);

	fprintf(fp, "<center>%c", LF);
	fprintf(fp, "<table border=0><font size=3><caption><b>%s...</b></caption></font>%c", rcd.szTitle, LF);

	/* new line */
	fprintf(fp, "<tr><th>  </th></tr>%c", LF);
	fprintf(fp, "<tr><th>  </th></tr>%c", LF);

	fprintf(fp, "<tr><th>۹ȣ</th><td>%4s</td><th> Ƚ   </th><td>%4s</td></tr>%c",
                rcd.szNumber, rcd.szCount, LF);
	fprintf(fp, "<tr><th>۾</th><td>%s</td><th>۾¥</th><td>%s</td></tr>%c",
				rcd.szName, szDate, LF);
	fprintf(fp, "<tr><th>E-mail</th><td><a href=mailto:%s>%s</a></td>",
				rcd.szEmail, rcd.szEmail);
	fprintf(fp, "<th>URL</th><td><a href=\"http://%s\">%s</a></td></tr>%c", url, url, LF);
	fprintf(fp, "<tr><th>Homepage</th><td><a href=\"%s\">%s</a></td></tr></table>%c", homepage, homepage, LF);

	fprintf(fp, "<img width=420 src=\"/Image/blue_line.gif\">%c", LF);
	fprintf(fp, "<br><br>%c", LF);
	

	fprintf(fp, "<table border=0>%c", LF);
	fprintf(fp, "<tr><td><font size=-1>%c", LF);
	/*
	** Write contents in the file
	*/
	for (i=0; i<(int)strlen(buf); i++)
	{
		if (*(buf+i) == CF) fprintf(fp, "<br>");
		else		    putc(*(buf+i), fp);
	}
	fprintf(fp, "</font></table>%c", LF);
	fprintf(fp, "<br>%c", LF);

	fprintf(fp, "<img src=\"/Image/line.gif\" width=500><br>%c", LF);

#ifdef _PRO_
	fprintf(fp, "<font color=454545 size=-1>Professional Version 1.01</font><br>%c", LF);
#else
	fprintf(fp, "<font color=454545 size=-1>Amateur Version 1.01</font><br>%c", LF);
#endif
	fprintf(fp, "<font color=454545 size=-1>Copyright <font size=4>&copy</font> 1996 - 1997,%c", LF);
	fprintf(fp, "Software Engineering Lab. All rights reserved.</br>%c", LF);
	fprintf(fp, "Chonbuk National Univ. Dept. of Electronic Engineering<br>%c", LF);
	fprintf(fp, "<a href=http://sel.chonbuk.ac.kr/~jkkang/><blink>Programmed by Kang Jul Ki</blink></a><br>%c", LF);
	fprintf(fp, "<a href=mailto:%s>%s</a></br>%c", E_MAIL, E_MAIL, LF);
	fprintf(fp, "</font>%c", LF);

	fprintf(fp, "</center>%c", LF);
	fprintf(fp, "</body>%c", LF);
	fprintf(fp, "</html>%c", LF);
}

/*
** Error()
*/
void Error(char *dir)
{
	printf("<html>%c", LF);
	printf("<body bgcolor=ffffff background=/Image/background.jpg%c", LF);

	printf("<br>%c", LF);
	printf("<center>%c", LF);
	printf("<br><br><br><br>%c", LF);

        printf("<font color=454545 size=2>湮 ̸, ,  ּ!!!</font><br>%c", LF);
	printf("<font color=4a708b size=2>You should write your name, title and comment!!!</font><br>%c", LF);
	printf("</center>%c", LF);
	printf("<br><br><br>%c", LF);
	printf("<center><a href=/Cgi-bin/TextHtml.exe?Dir=%s><img border=0 src=\"/Image/before.gif\"></a></center>%c", dir, LF);

	printf("<br><br>%c", LF);
	printf("<center>%c", LF);
	printf("<font color=4a708b size=-1>%c", LF);
		
	printf("<img src=/Image/line.gif width=500><br>%c", LF);

#ifdef _PRO_
	printf("<font color=454545 size=-1>Professional Version 1.01</font><br>%c", LF);
#else
	printf("<font color=454545 size=-1>Amateur Version 1.01</font><br>%c", LF);
#endif
	printf("<font color=454545 size=-1>Copyright <font size=4>&copy</font> 1996 - 1997,%c", LF);
	printf("Software Engineering Lab. All rights reserved.</br>%c", LF);
	printf("Chonbuk National Univ. Dept. of Electronic Engineering<br>%c", LF);
	printf("<a href=http://sel.chonbuk.ac.kr/~jkkang/><blink>Programmed by Kang Jul Ki</blink></a><br>%c", LF);
	printf("<a href=mailto:%s>%s</a></br>%c", E_MAIL, E_MAIL, LF);
	printf("</font>%c", LF);
	printf("</center>%c", LF);

	printf("</body>%c", LF);
	printf("</html>%c", LF);
	exit(1);
}
