/*
**	CGI Source for TextRead.Cgi
**	Author	: Kang Jul Ki
**	E-mail	: jkkang@sel.chonbuk.ac.kr
**	Homepage: http://sel.chonbuk.ac.kr/~jkkang/
**	Date	: February 3, 1997
**	Class	: Software Engineering Lab.
**		  Dept. of Electronic Engineering
**		  Chonbuk National Univ.	
**
**	Compiler: Visual C++ 4.0
**	Copyright (c) 1997, Kang Jul Ki & Software Engineering Lab.
*/

#include "mycgi.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

FILE_HEADER	fheader;

void main()
{
	int	i, iCount, rv;
	char	*buf, fname[255] = "", dir[200];
	entry	inparam[MAX_ENTRIES];
	int	iBoardNum, iTextNum, ch;
	long	lSkip;
	RECORD	*ptr;
	FILE	*fpt;
	fpos_t	pos;

	/*
	** Mime type
	*/
	printf("Content-type: text/html%c%c", LF, LF);

	buf = getenv("QUERY_STRING");

	for (i=0; i<3; i++)
	{
		inparam[i].f_val = (char *)makeword(buf, '&');
		inparam[i].f_name = (char *)makeword(inparam[i].f_val, '=');
#ifdef DEBUG
		printf("%s%c", inparam[i].f_name, LF);
		printf("%s<br>%c", inparam[i].f_val, LF);
#endif
	}

	/*
	** Read values from inparam
	*/
	iBoardNum = atoi(inparam[0].f_val);
	iTextNum  = atoi(inparam[1].f_val);
	strcpy(dir, inparam[2].f_val);

	/*
	** Update count in the "guestbook.dat"
	** fopen()
	**	'r' or 'rb'		open for reading
	**	'w' or 'wb'		truncate to zero length or create for writing
	**	'r+'or 'r+b'		open for update (reading and writing)
	**	'w+'or 'w+b'		truncate or create for update
	*/
	sprintf(fname, "%s%s", dir, "guestbook.dat");
	fpt = fopen(fname, "r+");

	if (fpt == NULL)
	{
		char str[100];

		sprintf(str, "Can't open %s!!!", "guestbook.dat");
		ShowErrorMsg(dir, str);
	}

	ptr = (RECORD *)malloc(RECORD_SIZE);
	if (ptr == NULL)
	{
		char str[100];
		
		sprintf(str, "%s", "Memory allocation error!!!");
		ShowErrorMsg(dir, str);
		//exit(1);
	}

	lSkip = HEADER_SIZE + RECORD_SIZE*(iTextNum-1);

	fseek(fpt, lSkip, SEEK_SET);	/* jump to the location	*/
	rv = fgetpos(fpt, &pos);	/* get current file ptr	*/

#ifdef _DEBUG_
	printf("rv = %d pos = %d%c<br>", rv, pos, LF);
#endif

	fread(ptr, RECORD_SIZE, 1, fpt);
	
	iCount = atoi(ptr->szCount);	/* convert string to interger	*/

#ifdef _DEBUG_
	printf("iCount = %d%c<br>", iCount, LF);
#endif

	iCount++;			/* increase 1			*/
	sprintf(ptr->szCount, "%4d", iCount);
	fsetpos(fpt, &pos);		/* set file potr into before	*/
	fwrite(ptr, RECORD_SIZE, 1, fpt);

#ifdef _DEBUG_
	printf("ptr->szCount = %s pos = %d%c<br>", ptr->szCount, pos, LF);
#endif

	fclose(fpt);

/* end of update */

	/*
	** Set file name from iBoardNum and iTextNum
	*/
	sprintf(fname, "%s%s", dir, ptr->szHtmlName);
	
#ifdef DEBUG
	printf("%c%s%c", LF, fname, LF);
#endif

	/*
	** Update count in the 'guestbook#.html'
	*/
	fpt = fopen(fname, "r+");	/* update file	*/

	if (fpt == NULL)
	{
		char str[100];

		sprintf(str, "Can't open %s!!!", fname);
		free(ptr);
		ShowErrorMsg(dir, str);
	}

	fprintf(fpt, "<html>%c", LF);
	fprintf(fpt, "<body bgcolor=\"ffffff\" background=\"/Image/background.jpg\">%c", LF);

	fprintf(fpt, "<center>%c", LF);
	fprintf(fpt, "<table border=0><font size=3><caption><b>%s...</b></caption></font>%c", ptr->szTitle, LF);

	/* new line */
	fprintf(fpt, "<tr><th>  </th></tr>%c", LF);
	fprintf(fpt, "<tr><th>  </th></tr>%c", LF);

	fprintf(fpt, "<tr><th>۹ȣ</th><td>%4s</td><th> Ƚ   </th><td>%4s</td></tr>%c",
                ptr->szNumber, ptr->szCount, LF);

	fclose(fpt);
	
	/* end of update 'guestbook#.html'	*/

	/*
	** Read 'guestbook#.html'
	*/
	fpt = fopen(fname, "r");

	if (fpt == NULL)
	{
		char str[100];

		free(ptr);
		sprintf(str, "Can't open %s!!!", fname);
		ShowErrorMsg(dir, str);
	}

	while ((ch = getc(fpt)) != EOF)
		putchar(ch);

	fclose(fpt);

	printf("<br><center><font color=4a708b size=-1><a href=/Cgi-bin/TextErase.exe?TextNum=%d&Dir=%s><img src=/Image/trash.gif border=0></a>%c", atoi(ptr->szNumber), dir, LF);
	printf("<br>Erase</font></center>%c", LF);
	
	free(ptr);
}
