/*
	CGI Source for Guest book

	Author	: Kang Jul Ki (Master 2nd)
	E-mail	: jkkang@sel.chonbuk.ac.kr
	Homepage: http://sel.chonbuk.ac.kr/~jkkang/
	Date	: January 29, 1997
	Class	: Software Engineering Lab.
		  Dept. of Electronic Engineering
		  Chonbuk National Univ.	

	Compiler: Visual C++ 4.0
	Copyright (c) 1997, Kang Jul Ki & Software Engineering Lab
*/

#ifndef __mycgi_h_
#define __mycgi_h_

#include <stdio.h>
#include <string.h>

/*
** You should set this macro into your Email Address
*/
#define	E_MAIL	"jkkang@sel.chonbuk.ac.kr"

#define	CF	13
#define	CR	13
#define	LF	10

#define MAX_ENTRIES 1000

typedef struct
{
    char *f_name;
    char *f_val;
} entry;

typedef struct
{
	char	szIndex[10];		/* number of guestbook#.html	*/
	char	szTotal[10];		/* total html file #		*/
	char	szPageNum[5];		/* number of page 'guest#.html'	*/
	char	szDummy[30];		/* dummy space			*/
} FILE_HEADER;
						
typedef struct {
	char	szNumber[5];		/* number of guest book	*/
	char	szName[20];		/* name of guest	*/
	char	szDate[20];		/* date 		*/
	char	szEmail[40];		/* email		*/
	char	szCount[10];		/* count that is read by someone*/
	char	szTitle[80];		/* title		*/
	char	szHtmlName[100];	/* html file name 	*/
} RECORD;

#define	HEADER_SIZE		(sizeof(FILE_HEADER))
#define	RECORD_SIZE		(sizeof(RECORD))

/*
** Prototype for util.c
*/
void getword		(char *word, char *line, char stop);
char *makeword		(char *line, char stop);
char *fmakeword		(FILE *f, char stop, int *cl);
char x2c		(char *what);
void unescape_url	(char *url);
void plustospace	(char *str);
int  rind		(char *s, char c);
int  getline		(char *s, int n, FILE *f);
void send_fd		(FILE *f, FILE *fd);
int  ind		(char *s, char c);
void escape_shell_cmd	(char *cmd);
void ShowErrorMsg	(char *dir, char *msg);

/*
** Prototype for TextPost.c
*/
void MakeHtmlPage	(FILE *in, int nTotal);
void MakeEachHtmlPage	(FILE *fp, char *buf, char *homepage, char *url, char *szDate);

/*
** Prototype for TextBoard.c
*/
void ShowBoard		(char *dir, int board, int iStart, int iEnd, int total);
//void ShowBoard	(int board, int iStart, int iEnd, int total);	// unix version
void GetArgument	(int bn, int tn, int *start, int *end, int total);
void ShowStart		(char *dir);

/*
** Prototype for TextErase.c
*/
void ShowError		(char *dir);
void ShowSuccess	(char *dir);


#endif	/* __mycgi_h_	*/
